﻿//////////////////////////////////////////////
// DecodedMaterialData.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

/// Class ------------------------------------

namespace nkGraphics
{
	struct DLL_GRAPHICS_EXPORT DecodedMaterialData final
	{
		// Attributes
		nkMaths::Vector _ambientColor = nkMaths::Vector(1, 1, 1) ;
		int _ambientTextureIndex = -1 ;

		nkMaths::Vector _diffuseColor = nkMaths::Vector(1, 1, 1) ;
		int _diffuseTextureIndex = -1 ;

		nkMaths::Vector _specularColor = nkMaths::Vector(1, 1, 1) ;
		int _specularTextureIndex = -1 ;

		float _roughnessFactor = 0.5f ;
		int _roughnessTextureIndex = -1 ;

		float _metalnessFactor = 0.5f ;
		int _metalnessTextureIndex = -1 ;

		int _occlusionTextureIndex = -1 ;
		float _occlusionFactor = 1.f ;

		int _normalTextureIndex = -1 ;

		float _alphaValue = 1.f ;
		int _alphaTextureIndex = -1 ;
	} ;
}