﻿//////////////////////////////////////////////
// AsyncWorker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Foward decl ------------------------------

namespace nkTasks
{
	class Scheduler ;
	class SchedulerTask ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT AsyncWorker : public nkCommon::SingletonClass<AsyncWorker>
	{
		friend class nkCommon::SingletonClass<AsyncWorker> ;

		private :
		
			// Attributs
			// Le scheduler utilisé pour les load de resources
			nkTasks::Scheduler* _resourceScheduler ;
			
		public :
		
			// Constructeur, destructeur
			AsyncWorker () ;
			~AsyncWorker () ;

			// Soumission travail
			void askForResourceWork (nkTasks::SchedulerTask* work) ;

			// Update
			void finalizeWork () ;
	} ;
}