﻿//////////////////////////////////////////////
// Rectangle.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "Point.h"

/// Class ------------------------------------

namespace nkMaths
{	
	class DLL_MATHS_EXPORT Rectangle final
	{
		public :

			// Attributes
			union
			{
				float _x ;
				float x ;
			} ;

			union
			{
				float _y ;
				float y ;
			} ;

			union
			{
				float _width ;
				float width ;
			} ;

			union
			{
				float _height ;
				float height ;
			} ;


		public :

			// Functions
			// Constructor, destructor
			Rectangle () ;
			Rectangle (float x, float y, float width, float height) ;
			~Rectangle () ;

			// Utilities
			bool pointInside (Point point) const ;

			// Operators
			Rectangle operator+ (const Rectangle& other) const ;
	} ;
}